import javax.persistence.*;

public class Main {

    /* This program works both in Java SE as well as Java EE environment */
    @PersistenceUnit private static EntityManagerFactory emf;

    public static void main(String... args) throws Exception {
        if(emf == null) { // no injection => Java SE
            System.out.println("Defaulting to Java SE enviroment");
            emf = Persistence.createEntityManagerFactory("pu1", null);
        }
        EntityManager em = emf.createEntityManager();
        if(args.length == 0) {
            System.out.println("Usage: java "+ Main.class.getName() + " <name...>");
            System.exit(1);
        }
        for(String id : args) {
            EntityTransaction et = em.getTransaction();
            et.begin();
            String eventPK = id;
            System.out.println("*******Finding event " + eventPK);
            Event event = em.find(Event.class, eventPK);
            if(event == null) {
                event = new Event();
                event.setNotificationId(id);
                System.out.println("Creating event " + event);
                em.persist(event);
            } else {
                System.out.println("Found " + event);
            }
            String alarmPK = id;
            System.out.println("*******Finding alarm " + alarmPK);
            Alarm alarm = em.find(Alarm.class, alarmPK);
            if(alarm == null) {
                alarm = new Alarm();
                alarm.setNotificationId(alarmPK);
                alarm.setEvent(event);
                System.out.println("Creating alarm " + alarm);
                em.persist(alarm);
            } else {
                System.out.println("Found " + alarm);
            }
            et.commit();
        }
        em.close();
    }
}
